/*
   Test the group routines
   (some tested elsewere)

MPI_Group_compare
MPI_Group_excl
MPI_Group_intersection
MPI_Group_range_excl
MPI_Group_rank
MPI_Group_size
MPI_Group_translate_ranks
MPI_Group_union

 */
//#include "mpi.h"
//#include <stdio.h>
//#include <memory.h>
/* stdlib.h Needed for malloc declaration */
//#include <stdlib.h>
import mpi.*;

//int main( argc, argv )
//int  argc;
//char **argv;
class grouptest {
  static public void main(String[] args) {

    //MPI_Init( &argc, &argv );
    MPI.Init(args);

    int errs=0, toterr;
    //MPI_Group basegroup;
    //MPI_Group g1, g2, g3, g4, g5, g6, g7, g8, g9;

    Group basegroup ;//= new Group();
    Group g1 = new Group(); Group g2 = new Group();
    Group g3 = new Group(); Group g4 = new Group();
    Group g5 = new Group(); Group g6 = new Group();
    Group g7 = new Group(); Group g8 = new Group();
    Group g9 = new Group();

    //MPI_Comm  comm, newcomm, splitcomm, dupcomm;
    Comm comm;//      = new Comm();
    Comm newcomm   = new Comm();
    Comm splitcomm = new Comm();
    Comm dupcomm   = new Comm();
    int   i, grp_rank, rank, grp_size, size, result;
    //int       nranks, *ranks, *ranks_out;
    int       nranks, ranks[], ranks_out[];
    //int       range[1][3];
    int       range[][] = new int[1][3];
    //int       range[];
    int       worldrank;



    //MPI_Comm_rank( MPI_COMM_WORLD, &worldrank );
    worldrank = MPI.COMM_WORLD.Rank();

    //comm = MPI_COMM_WORLD;
    comm = MPI.COMM_WORLD;
    //Comm comm = new Comm(Comm.WORLD);
    //MPI_Comm_group( comm, &basegroup );
    basegroup = comm.Group();

/* Get the basic information on this group */
    //MPI_Group_rank( basegroup, &grp_rank );
    grp_rank = basegroup.Rank();
 
   //MPI_Comm_rank( comm, &rank );
    rank = comm.Rank();

    if (grp_rank != rank) {
      errs++;
      System.out.println
	( "group rank "+grp_rank+" != comm rank "+rank );
    }

    //MPI_Group_size( basegroup, &grp_size );
    grp_size = basegroup.Size();

    //MPI_Comm_size( comm, &size );
    size = comm.Size();


    if (grp_size != size) {
      errs++;
      System.out.println
	("group size "+grp_size+" != comm size "+size );
    }
System.out.println
  ("rank= "+rank+", size= "+size);
System.out.println
  ("grp_rank= "+grp_rank+", grp_size= "+grp_size);

/* Form a new communicator with inverted ranking */
    //MPI_Comm_split( comm, 0, size - rank, &newcomm );
    newcomm = comm.Split( 0,  size - rank);
    //MPI_Comm_group( newcomm, &g1 );
    g1 = newcomm.Group();
    //ranks   = (int *)malloc( size * sizeof(int) );
    ranks     = new int[size];
    //ranks_out = (int *)malloc( size * sizeof(int) );
    ranks_out = new int[size];
    for (i=0; i<size; i++) ranks[i] = i;
    nranks = size;

    //MPI_Group_translate_ranks( g1, nranks, ranks, basegroup, ranks_out );
    ranks_out = Group.Translate_ranks( g1, ranks, basegroup );

    for (i=0; i<size; i++) {
      if (ranks_out[i] != (size - 1) - i) {
	errs++;
	System.out.println( "Translate ranks got %d expected "+ 
			    ranks_out[i]+","+ ((size - 1) - i) );
      }
    }

    /* Check Compare */
    //MPI_Group_compare( basegroup, g1, &result );
    //result = g.Compare( basegroup, g1); 
    result = Group.Compare( basegroup, g1); 
    if (result != MPI.SIMILAR) {
      errs++;
      System.out.println
	( "Group compare should have been similar, was "+
	  result );
    }
    //MPI_Comm_dup( comm, &dupcomm );
    dupcomm = comm.Dup();
    //MPI_Comm_group( dupcomm, &g2 );
    g2 = dupcomm.Group();
    //MPI_Group_compare( basegroup, g2, &result );
    result = Group.Compare( basegroup, g2 );

    if (result != MPI.IDENT) {
      errs++;
      System.out.println
	( "Group compare should have been ident, was "+
	  result );
    }


    //MPI_Comm_split( comm, rank < size/2, rank, &splitcomm );
    /*************************************************** 
    splitcomm = comm.Split( rank < size/2, rank );
    //MPI_Comm_group( splitcomm, &g3 );
    g3 = splitcomm.Group();
    //MPI_Group_compare( basegroup, g3, &result );
    result = Group.Compare( basegroup, g3 );
    if (result != MPI.UNEQUAL) {
      errs++;
      System.out.println
	( "Group compare should have been unequal, was "+
	  result );
    }
    ****************************************************/


/* Build two new groups by excluding members; use Union to put them
   together again */
    // NOT supported in mpiJava
    /*************************************************** 
    //////////////////////////////////////////////////////
    // Exclude 0 
    //MPI_Group_excl( basegroup, 1, ranks, &g4 );
    System.out.println("size of ranks ="+size);
    g4 = basegroup.Excl( ranks );
    // Exclude 1-(size-1) 
    MPI_Group_excl( basegroup, size-1, ranks+1, &g5 );

    //MPI_Group_union( g5, g4, &g6 );
    g6 = Group.Union(g5, g4);
    //MPI_Group_compare( basegroup, g6, &result );
    result = Group.Compare(basegroup, g6);
    if (result != MPI.IDENT) {
      errs++;
      // See ordering requirements on union 
    System.out.println
      ( "Group excl and union did not give ident groups" );
    }
    //MPI_Group_union( basegroup, g4, &g7 );
    g7 = Group.union(basegroup, g4);
    //MPI_Group_compare( basegroup, g7, &result );
    result = Group.Compare(basegroup, g7);
    if (result != MPI.IDENT) {
      errs++;
      System.out.println
	( "Group union of overlapping groups failed" );
    }
    *******************************************************/


/* Use range_excl instead of ranks */
    range[0][0] = 1;
    range[0][1] = size-1;
    range[0][2] = 1;
    //MPI_Group_range_excl( basegroup, 1, range, &g8 );
    g8 = basegroup.Range_excl( range );
    //MPI_Group_compare( g5, g8, &result );
    result = Group.Compare(basegroup, g8);
    if (result != MPI.IDENT) {
      errs++;
      System.out.println
	( "Group range excl did not give ident groups" );
    }

    //MPI_Group_intersection( basegroup, g4, &g9 );
    g9 = Group.Intersection(basegroup, g4);
    //MPI_Group_compare( g9, g4, &result );
    result = Group.Compare(basegroup, g9);
    if (result != MPI.IDENT) {
      errs++;
      System.out.println
	( "Group intersection did not give ident groups" );
    }



    //////////////////////////////////////////////////////
    //MPI_Group_free( &basegroup );
    //MPI_Group_free( &g1 );
    //MPI_Group_free( &g2 );
    //MPI_Group_free( &g3 );
    //MPI_Group_free( &g4 );
    //MPI_Group_free( &g5 );
    //MPI_Group_free( &g6 );
    //MPI_Group_free( &g7 );
    //MPI_Group_free( &g8 );
    //MPI_Group_free( &g9 );
    //MPI_Comm_free( &dupcomm );
    //MPI_Comm_free( &splitcomm );
    //MPI_Comm_free( &newcomm );
    /*
    basegroup.finalize();
    g1.finalize();
    g2.finalize();
    g3.finalize();
    g4.finalize();
    g5.finalize();
    g6.finalize();
    g7.finalize();
    g8.finalize();
    g9.finalize();
    dupcomm.Free();
    splitcomm.Free();
    newcomm.Free();
    */
    //MPI_Allreduce( &errs, &toterr, 1, MPI_INT, MPI_SUM, MPI_COMM_WORLD );
    /*
    if (worldrank == 0) {
      if (toterr == 0) 
	System.out.println( "No errors in MPI Group routines" );
      else
	System.out.println
	  ( "Found %d errors in MPI Group routines "+ toterr );
    }
    */
    MPI.Finalize();
    //return toterr;
  }
}



